您的位置:首页 > 其它

hdu 4472 dp

2014-10-30 22:35 197 查看
[align=left]Problem Description[/align]
Prof. Tigris is the head of an archaeological team who is currently in charge of an excavation in a site of ancient relics.

This site contains relics of a village where civilization once flourished. One night, examining a writing record, you find some text meaningful to you. It reads as follows.

“Our village is of glory and harmony. Our relationships are constructed in such a way that everyone except the village headman has exactly one direct boss and nobody will be the boss of himself, the boss of boss of himself, etc. Everyone expect the headman
is considered as his boss’s subordinate. We call it relationship configuration. The village headman is at level 0, his subordinates are at level 1, and his subordinates’ subordinates are at level 2, etc. Our relationship configuration is harmonious because
all people at same level have the same number of subordinates. Therefore our relationship is …”

The record ends here. Prof. Tigris now wonder how many different harmonious relationship configurations can exist. He only cares about the holistic shape of configuration, so two configurations are considered identical if and only if there’s a bijection of
n people that transforms one configuration into another one.

Please see the illustrations below for explanation when n = 2 and n = 4.



The result might be very large, so you should take module operation with modules 109 +7 before print your answer.

[align=left]Input[/align]
There are several test cases.

For each test case there is a single line containing only one integer n (1 ≤ n ≤ 1000).

Input is terminated by EOF.

[align=left]Output[/align]
For each test case, output one line “Case X: Y” where X is the test case number (starting from 1) and Y is the desired answer.

[align=left]Sample Input[/align]

1
2
3
40
50
600
700


[align=left]Sample Output[/align]

Case 1: 1
Case 2: 1
Case 3: 2
Case 4: 924
Case 5: 1998
Case 6: 315478277
Case 7: 825219749


将父节点去掉,因为这个只有一种放法,于是还剩下n-1个点。因为每一层的每个节点的子节点数相同,将这n-1个节点m等分,再递归求解。

代码:

#include <cstdio>
#include <cstring>
#define N 1010
#define MOD 1000000007

long long dp
;
int n;

void DP()
{
memset(dp,0,sizeof(dp));
dp[1]=1; dp[2]=1;
for(int i=3; i<=1000; i++)
for(int j=1; j<=i-1; j++)
if((i-1)%j == 0)
dp[i] = (dp[i]+dp[j])%MOD;
}

int main()
{
DP();
int ccase=0;
while(scanf("%d",&n)!=EOF)
{
printf("Case %d: %lld\n",++ccase,dp
);
}
return 0;
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: